##################### generated by xml-casa (v2) from imhistory.xml #################
##################### bb68db34e36ca4abbe694ff07ec721b1 ##############################
from __future__ import absolute_import
import numpy
from casatools.typecheck import CasaValidator as _val_ctor
_pc = _val_ctor( )
from casatools.coercetype import coerce as _coerce
from casatools.errors import create_error_string
from .private.task_imhistory import imhistory as _imhistory_t
from casatasks.private.task_logging import start_log as _start_log
from casatasks.private.task_logging import end_log as _end_log
from casatasks.private.task_logging import except_log as _except_log

class _imhistory:
    """
    imhistory ---- Retrieve and modify image history

    
    Retrieve and modify image history.
    
    This task provides access to the logtable of an image, where generally
    history information is stored. Two operation modes are supported. When
    mode="list", the history messages are returned as an array of
    strings. If verbose=True, this information is also written to the
    logger. When mode="append", a specified message (along with its
    specified origin) are appended to the logtable and True is returned if
    successful.

    --------- parameter descriptions ---------------------------------------------

    imagename Name of the input (CASA or FITS) image
              Default: none
              
                 Example: imagename='ngc5921.im'
    mode      Operating mode.
              Default: 'list' (retrieve history)
              Options: 'list|append' ('append' to append a
              record to history)
    verbose   Write history to logger if mode="list"?
              Subparameter of mode='list'
              Default: True
              Options: True|False
    origin    Origin of appended message. 
              Subparameter of mode='append'
              Default: 'imhistory'
              
              The user can specify any string. This string will
              appear as a tag at the start of the appended line
              in the image history. Only used for mode="append".
    message   Message to append. 
              Subparameter of mode='append'
              Default: none
              
              Only used of mode="append".
    [1;42mRETURNS[1;m      variant

    --------- examples -----------------------------------------------------------

    
    FOR MORE INFORMATION, SEE THE TASK PAGES OF IMHISTORY IN CASA DOCS:
    https://casa.nrao.edu/casadocs/


    """

    _info_group_ = """information,analysis"""
    _info_desc_ = """Retrieve and modify image history"""

    def __call__( self, imagename='', mode='list', verbose=True, origin='imhistory', message='' ):
        schema = {'imagename': {'type': 'cReqPath', 'coerce': _coerce.expand_path}, 'mode': {'type': 'cStr', 'coerce': _coerce.to_str}, 'verbose': {'type': 'cBool'}, 'origin': {'type': 'cStr', 'coerce': _coerce.to_str}, 'message': {'type': 'cStr', 'coerce': _coerce.to_str}}
        doc = {'imagename': imagename, 'mode': mode, 'verbose': verbose, 'origin': origin, 'message': message}
        assert _pc.validate(doc,schema), create_error_string(_pc.errors)
        _logging_state_ = _start_log( 'imhistory', [ 'imagename=' + repr(_pc.document['imagename']), 'mode=' + repr(_pc.document['mode']), 'verbose=' + repr(_pc.document['verbose']), 'origin=' + repr(_pc.document['origin']), 'message=' + repr(_pc.document['message']) ] )
        task_result = None
        try:
            task_result = _imhistory_t( _pc.document['imagename'], _pc.document['mode'], _pc.document['verbose'], _pc.document['origin'], _pc.document['message'] )
        except Exception as exc:
            _except_log('imhistory', exc)
            raise
        finally:
            task_result = _end_log( _logging_state_, 'imhistory', task_result )
        return task_result

imhistory = _imhistory( )

