##################### generated by xml-casa (v2) from listfits.xml ##################
##################### 0c3a13a91049d6b017e5c5d3709f67d1 ##############################
from __future__ import absolute_import
import numpy
from casatools.typecheck import CasaValidator as _val_ctor
_pc = _val_ctor( )
from casatools.coercetype import coerce as _coerce
from casatools.errors import create_error_string
from .private.task_listfits import listfits as _listfits_t
from casatasks.private.task_logging import start_log as _start_log
from casatasks.private.task_logging import end_log as _end_log
from casatasks.private.task_logging import except_log as _except_log

class _listfits:
    """
    listfits ---- List the HDU and typical data rows of a fits file:

    
    List the HDU and typical data rows of a fits file:
    The list will be given in the logger.
    

    --------- parameter descriptions ---------------------------------------------

    fitsfile Name of input fits file
    [1;42mRETURNS[1;m     void

    --------- examples -----------------------------------------------------------

    
    
    The HDU and typical data rows in a fits file are listed in the logger.
    
    Keyword arguments:
    fitsfile -- Name of input fits file
    default: none; example: fitsfile='ngc5921.uvfits'
    


    """

    _info_group_ = """information"""
    _info_desc_ = """List the HDU and typical data rows of a fits file:"""

    def __call__( self, fitsfile='' ):
        schema = {'fitsfile': {'type': 'cReqPath', 'coerce': _coerce.expand_path}}
        doc = {'fitsfile': fitsfile}
        assert _pc.validate(doc,schema), create_error_string(_pc.errors)
        _logging_state_ = _start_log( 'listfits', [ 'fitsfile=' + repr(_pc.document['fitsfile']) ] )
        task_result = None
        try:
            task_result = _listfits_t( _pc.document['fitsfile'] )
        except Exception as exc:
            _except_log('listfits', exc)
            raise
        finally:
            task_result = _end_log( _logging_state_, 'listfits', task_result )
        return task_result

listfits = _listfits( )

