##################### generated by xml-casa (v2) from rmtables.xml ##################
##################### 9c9e8a04e66b72709cb57b410e3e40a4 ##############################
from __future__ import absolute_import
import numpy
from casatools.typecheck import CasaValidator as _val_ctor
_pc = _val_ctor( )
from casatools.coercetype import coerce as _coerce
from casatools.errors import create_error_string
from .private.task_rmtables import rmtables as _rmtables_t
from casatasks.private.task_logging import start_log as _start_log
from casatasks.private.task_logging import end_log as _end_log
from casatasks.private.task_logging import except_log as _except_log

class _rmtables:
    """
    rmtables ---- Remove tables cleanly, use this instead of rm -rf

    
    This task removes tables if they are not being currently accessed via
    the casapy process. Note: if you have multiple sessions running bad things
    could happen if you remove a table being accessed by another process.
    

    --------- parameter descriptions ---------------------------------------------

    tablenames Name of the tables

    --------- examples -----------------------------------------------------------

    
    Removes tables cleanly.
    Arguments may contain * or ?. Ranges [] are support but
    not ~ expansion.
    


    """

    _info_group_ = """manipulation"""
    _info_desc_ = """Remove tables cleanly, use this instead of rm -rf"""

    def __call__( self, tablenames=[  ] ):
        schema = {'tablenames': {'type': 'cStrVec', 'coerce': [_coerce.to_list,_coerce.to_strvec]}}
        doc = {'tablenames': tablenames}
        assert _pc.validate(doc,schema), create_error_string(_pc.errors)
        _logging_state_ = _start_log( 'rmtables', [ 'tablenames=' + repr(_pc.document['tablenames']) ] )
        task_result = None
        try:
            task_result = _rmtables_t( _pc.document['tablenames'] )
        except Exception as exc:
            _except_log('rmtables', exc)
            raise
        finally:
            task_result = _end_log( _logging_state_, 'rmtables', task_result )
        return task_result

rmtables = _rmtables( )

